{*******************************************}
{                                           }
{            FastReport v2.2                }
{                                           }
{   Editeur d'expression                    }
{ (C) Guilbaud Olivier                      }
{        golivier@bigfoot.com               }
{                                           }
{ FastReport :(c) 1998-99 by Tzyganenko A.  }
{                                           }
{ Merci de transmettre vos commantaires &   }
{ modifications                             }
{Ceci est un FREEWARE il peut tre utilis  }
{librement.                                 }
{ Attention : vous cette unit fait partie  }
{ du patch 1.2 mini de FR.
{*******************************************}
{Histo :                                    }
{ 03/06/99 : Cration                       }
{ 04/06/99 : Corrections minueurs
             ajout le bouton "Dfaire"
}


unit edExpr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons,DB,
  FR_Utils,Fr_Class, ComCtrls;

type
  TExprEditor = class(TSForm)
    moExpres: TMemo;
    GroupBox1: TGroupBox;
    edConst: TEdit;
    cbConstType: TComboBox;
    BitBtn1: TBitBtn;
    GroupBox2: TGroupBox;
    Panel1: TPanel;
    BUndo: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    GroupBox3: TGroupBox;
    cbCatFunction: TComboBox;
    lbFunction: TListBox;
    baddFct: TBitBtn;
    HlpFct1: TLabel;
    GroupBox4: TGroupBox;
    rbVarOrData: TRadioGroup;
    cbCatData: TComboBox;
    lbData: TListBox;
    BitBtn7: TBitBtn;
    Panel2: TPanel;
    Panel3: TPanel;
    tbOper: TTabControl;
    Panel4: TPanel;
    pnMath: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    pnLogique: TPanel;
    Button6: TButton;
    Button5: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button13: TButton;
    Button12: TButton;
    Button14: TButton;
    Button17: TButton;
    Button18: TButton;
    moHlp2: TMemo;
    procedure FormActivate(Sender: TObject);
    procedure tbOperChange(Sender: TObject);
    procedure rbVarOrDataClick(Sender: TObject);
    procedure cbCatDataClick(Sender: TObject);
    procedure cbCatFunctionClick(Sender: TObject);
    procedure lbFunctionClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure baddFctClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BUndoClick(Sender: TObject);
  private
    { Dclarations prives }
    CurExp : String; // Chaine gnr par un bouton add
    UndoLst: TStringList;
    Procedure AddFctStandard(CatIndex : Integer);
  public
    { Dclarations publiques }

    function CurVal:String;
    function CurDataSet:String;
    procedure GetFields(Value:String);
    procedure GetSpecValues;
    procedure FillValCombo;
    Procedure FillCatCombo;
    Procedure FillFctList(CatIndex : Integer);

    Function DecodeFrCat(S : String; n : Integer):String;
    function GetDBField : String;
    Procedure TraiteSaisie;
  end;

var
  ExprEditor: TExprEditor;

implementation
{$R *.DFM}
Uses edExpPar;

Const
   FctStdCnt = 6;
   FctStd   : Array[1..FctStdCnt] of String =('IF','INT','FRAC','COPY','ROUND','STR');
   
Procedure TExprEditor.TraiteSaisie;
Var OldExp : String;
Begin
  if CurExp='' then exit;
  OldExp:=moExpres.Text;
  moExpres.Text:=moExpres.Text+CurExp;
  CurExp:='';
  UndoLst.Add(OldExp);
  BUndo.Enabled:=(UndoLst.Count<>0);
end;

Procedure TExprEditor.FillCatCombo;
Var FctLib  : TfrFunctionLibrary;
    I,J     : Integer;
    LstT    : TStringList;
    S       : String;
Begin
 Try
  LstT:=TStringList.Create;
  LstT.Sorted:=True;
  LstT.Duplicates:=dupIgnore;

  cbCatFunction.Items.Clear;
  cbCatFunction.Items.Add(FrLoadStr('sCatAll'));
  cbCatFunction.Text:='';
  For i:=0 to frFunctionsCount-1 do
  Begin
    FctLib:=frFunctions[i].FunctionLibrary;
    For J:=0 to FctLib.List.Count-1 do
    Begin
      S:=FctLib.List.Strings[J];
      S:=DecodeFrCat(S,1);
      if S='' then S:=frLoadStr('sCatInconnue');
      LstT.Add(S);
    end;
  end;

  For J:=1 to FctStdCnt do
  Begin
    S:=FctStd[J];
    S:=DecodeFrCat(S,1);
    if S='' then S:=frLoadStr('sCatInconnue');
    LstT.Add(S);
  end;

  cbCatFunction.Items.AddStrings(LstT);
  cbCatFunction.ItemIndex:=0;

 finally
  LstT.Free;
 end;
end;

Procedure TExprEditor.FillFctList(CatIndex : Integer);
Var FctLib : TfrFunctionLibrary;
    I,J    : Integer;
    S,St   : String;
    Ajout  : Boolean;
    Lst    : TStringList;
Begin
  lbFunction.Items.Clear;
  For i:=0 to frFunctionsCount-1 do
  Begin
    FctLib:=frFunctions[i].FunctionLibrary;
    For J:=0 to FctLib.List.Count-1 do
    begin
      s:=FctLib.List.Strings[J];
      st:=CbCatFunction.Items.Strings[CatIndex];
      if St=frloadStr('sCatInconnue') then St:=''; // catgorie inconnue
      Ajout:=(CatIndex=0) or (St=DecodeFrCat(FrLoadStr(S),1));
      If Ajout then lbFunction.Items.Add(S)
    end;

  end;

  AddFctStandard(CatIndex);

  // force le trie
  Try
   Lst:=TStringList.Create;
   Lst.Assign(lbFunction.Items);
   Lst.Sort;
   lbFunction.Items.Assign(Lst);
  finally
   Lst.free;
  end;

end;

Procedure TExprEditor.AddFctStandard(CatIndex : Integer);
Var Aj    : Boolean;
    St    : String;
    i     : Integer;
Begin
  Aj:=(CatIndex=0);
  ST:=cbCatFunction.Items.Strings[CatIndex];
  if St=frLoadStr('sCatInconnue') then St:='';

  For i:=1 to FctStdCnt do
    If Aj or (St=DecodeFrCat(FctStd[i],1)) then
      lbFunction.Items.ADD(FctStd[i]);
end;

procedure TExprEditor.FormActivate(Sender: TObject);
Var i : Integer;
begin
  // Langue
  LoadLanguageId('ExpresEditor');

  // Init Memo
  if moExpres.text<>'' then
    moExpres.SelStart:=Length(moExpres.Text);
  // Oprateurs
  tbOper.TabIndex:=0;
  pnMath.Visible:=True;
  pnLogique.visible:=False;

  // les variable
  rbVarOrData.ItemIndex:=0;

  // Init List functions
  FillCatCombo;
  FillFctList(0);
  lbFunction.ItemIndex:=0;
  lbFunctionClick(NIL);
end;

procedure TExprEditor.tbOperChange(Sender: TObject);
begin
  pnMath.Visible:=(tbOper.TabIndex=0);
  pnLogique.Visible:=Not pnMath.Visible;
end;

procedure TExprEditor.rbVarOrDataClick(Sender: TObject);
begin
  Case rbVarOrData.ItemIndex of
   0 : Begin
         CurReport.GetCategoryList(cbCatData.Items);
         cbCatData.ItemIndex := 0;
         cbCatDataClick(nil);
       end;
   1 : Begin
         FillValCombo;
         cbCatData.ItemIndex := 0;
         cbCatDataClick(nil);
       end;
  end;

end;

function TExprEditor.CurDataSet:String;
begin
  Result := '';
  if cbCatData.ItemIndex <> -1 then
    Result := cbCatData.Items[cbCatData.ItemIndex];
end;

function TExprEditor.CurVal:String;
begin
  Result := '';
  if lbData.ItemIndex <> -1 then
    Result := lbData.Items[lbData.ItemIndex];
end;

procedure TExprEditor.FillValCombo;
var i: Integer;
    s: TStringList;
procedure EnumDataSets(f:TComponent);
var i: Integer;
    c: TComponent;
begin
  for i := 0 to f.ComponentCount-1 do
  begin
    c := f.Components[i];
    if c is TDataSet then
      if f = CurReport.Owner then
        s.Add(c.Name) else
        s.Add(f.Name + '.' + c.Name);
  end;
end;
begin
  s := TStringList.Create;
  for i := 0 to Screen.FormCount-1 do
    EnumDataSets(Screen.Forms[i]);
  for i := 0 to Screen.DataModuleCount-1 do
    EnumDataSets(Screen.DataModules[i]);
  s.Sort;
  s.Add(frLoadStr('SSpecVal'));
  cbCatData.Items.Assign(s);
  s.Free;
end;

procedure TExprEditor.GetFields(Value: String);
var DataSet: TDataSet;
    i: Integer;
    SaveAct: Boolean;
begin
  lbData.Items.Clear;
  DataSet := frGetDataSet(Value);
  with DataSet do
  begin
    SaveAct := Active;
    try
      Active := True;
      if FieldCount > 0 then
        for i := 0 to FieldCount-1 do
          lbData.Items.Add(Fields[i].FieldName)
      else
        for i := 0 to FieldDefs.Count-1 do
          lbData.Items.Add(FieldDefs.Items[i].Name);
    except
      on Exception do;
    end;
    Active := SaveAct;
  end;
end;

procedure TExprEditor.GetSpecValues;
var i: Integer;
begin
  with lbData.Items do
  begin
    Clear;
    for i := 0 to frSpecCount-1 do
      if i <> 1 then
        Add(frSpecArr[i]);
  end;
end;


Function TExprEditor.GetDbField: String;
begin
  Result:='';
  if rbVarOrData.ItemIndex=1 then
  begin
    if cbCatData.Text<> frLoadStr('SSpecVal') then
    begin
      if lbData.ItemIndex>=0 then Result:= cbCatData.Text + '."' + LbData.Items.Strings[lbData.ItemIndex] + '"'
                             else Result:='';
    end
    else
      if lbData.ItemIndex >=0 then
        Result:= lbData.Items.Strings[lbData.ItemIndex];
   end;
end;

procedure TExprEditor.cbCatDataClick(Sender: TObject);
begin
 Case rbVarOrData.ItemIndex of
   0 : CurReport.GetVarList(cbCatData.ItemIndex,lbData.Items);
   1 : Begin
        if CurDataSet <> frLoadStr('SSpecVal') then
          GetFields(CurDataSet)
        else GetSpecValues;
       end;
 end;
end;

procedure TExprEditor.cbCatFunctionClick(Sender: TObject);
begin
  FillFctList(cbCatFunction.ItemIndex);
  if lbFunction.Items.Count>0 then
  Begin
    lbFunction.ItemIndex:=0;
    lbFunctionClick(NIL);
  end;
end;

Function TExprEditor.DecodeFrCat(S : String; n : Integer):String;
Var Cg,C,H1,H2 : String;
Begin
  Cg :=FrLoadStr(S);
  C:=trim(Copy(Cg,1,Pos('|',Cg)-1));
  System.Delete(Cg,1,Pos('|',Cg));

  H1:=Trim(Copy(Cg,1,Pos('|',Cg)-1));
  System.Delete(Cg,1,Pos('|',Cg));

  H2:=Trim(Cg);

  Result:='';

  Case n of
   1 : Result:=C;
   2 : Result:=H1;
   3 : Result:=H2;
  end;
end;

procedure TExprEditor.lbFunctionClick(Sender: TObject);
Var Cg,C,H1,H2 : String;
    S          : String;
Begin
  S:=lbFunction.Items.Strings[lbFunction.itemIndex];
  Cg :=FrLoadStr(S);
  C:=Copy(Cg,1,Pos('|',Cg)-1);
  System.Delete(Cg,1,Pos('|',Cg));

  H1:=Copy(Cg,1,Pos('|',Cg)-1);
  System.Delete(Cg,1,Pos('|',Cg));

  H2:=Cg;

  HlpFct1.Caption:=H1;
  moHlp2.Lines.Clear;
  moHlp2.Lines.Add(H2);
end;

procedure TExprEditor.BitBtn1Click(Sender: TObject);
begin
  Case cbConstType.ItemIndex of
    0 : If Pos('"',edConst.Text)=0 then
         CurExp:='"'+edConst.Text+'"';
    1 : CurExp:=edConst.Text;
  end;

  TraiteSaisie;
  edConst.Text:='';
end;

procedure TExprEditor.FormCreate(Sender: TObject);
begin
  CurExp:='';
  moExpres.Lines.Clear;
  // liste des modif
  UndoLst:=TStringList.Create;
end;

procedure TExprEditor.Button1Click(Sender: TObject);
begin
  if Sender is TButton then
   CurExp:=TButton(Sender).Caption;
  TraiteSaisie; 
end;

procedure TExprEditor.BitBtn3Click(Sender: TObject);
begin
  UndoLst.Add(moExpres.Text);
  moExpres.Text:='';
  BUndo.Enabled:=(UndoLst.Count<>0);
end;

procedure TExprEditor.BitBtn7Click(Sender: TObject);
begin
  Case rbVarOrData.ItemIndex of
   0 : Begin //Variable
         if lbData.ItemIndex<>-1 then
           CurExp:='['+lbData.items.Strings[lbData.ItemIndex]+']';
       end;
   1 : Begin
         CurExp:=GetDbField;
         if CurExp<>'' then CurExp:='['+CurExp+']';
       end;
  end;

  TraiteSaisie;
end;

procedure TExprEditor.baddFctClick(Sender: TObject);
Var FctBase,ST : String;
    edPar   : TedParamFct;
begin
   //Recupre la fonction ou (..)
   If sender=bAddFct then ST:=HlpFct1.Caption
                     else St:='(<X>)';

   FctBase:=Copy(ST,1,Pos('(',ST)); // copie 'XXXX('

   Try
    edPar:=TedParamFct.Create(SELF);
    edPar.hlp1.Caption:=St;
    if Sender=BAddFct then edPar.hlp2.Text:=moHlp2.Text
                      else edPar.hlp2.Text:='';

    CurExp:='';
    If edPar.ShowModal=mrOk then
      CurExp:=FctBase+edPar.ResultPar+')';

    TraiteSaisie;
  finally
    edPar.Free;
  end;
end;

procedure TExprEditor.FormDestroy(Sender: TObject);
begin
  UndoLst.Free;
end;

procedure TExprEditor.BUndoClick(Sender: TObject);
begin
  moExpres.text:=UndoLst.Strings[UndoLst.Count-1];
  UndoLst.Delete(UndoLst.Count-1);
  BUndo.Enabled:=(UndoLst.Count<>0);
end;

end.
